diff -uNr mythtv-0.21/bindings/perl/IO/Socket/INET/MythTV.pm mythtv/bindings/perl/IO/Socket/INET/MythTV.pm
--- mythtv-0.21/bindings/perl/IO/Socket/INET/MythTV.pm	2007-12-01 22:49:49.000000000 +0100
+++ mythtv/bindings/perl/IO/Socket/INET/MythTV.pm	2007-12-01 22:49:49.000000000 +0100
@@ -3,8 +3,8 @@
 # A MythTV Socket class that extends IO::Socket::INET to include some
 # MythTV-specific data queries
 #
-# @url       $URL: http://svn.mythtv.org/svn/tags/release-0-21/mythtv/bindings/perl/IO/Socket/INET/MythTV.pm $
-# @date      $Date: 2007-12-01 21:49:49 +0000 (Sat, 01 Dec 2007) $
+# @url       $URL: http://svn.mythtv.org/svn/branches/release-0-21-fixes/mythtv/bindings/perl/IO/Socket/INET/MythTV.pm $
+# @date      $Date: 2007-12-01 22:49:49 +0100 (Sa, 01. Dez 2007) $
 # @version   $Revision: 15016 $
 # @author    $Author: xris $
 # @copyright Silicon Mechanics
diff -uNr mythtv-0.21/bindings/perl/MythTV/Channel.pm mythtv/bindings/perl/MythTV/Channel.pm
--- mythtv-0.21/bindings/perl/MythTV/Channel.pm	2007-03-13 06:13:27.000000000 +0100
+++ mythtv/bindings/perl/MythTV/Channel.pm	2007-03-13 06:13:27.000000000 +0100
@@ -3,8 +3,8 @@
 #
 # Object containing info about a particular MythTV channel.
 #
-# @url       $URL: http://svn.mythtv.org/svn/tags/release-0-21/mythtv/bindings/perl/MythTV/Channel.pm $
-# @date      $Date: 2007-03-13 05:13:27 +0000 (Tue, 13 Mar 2007) $
+# @url       $URL: http://svn.mythtv.org/svn/branches/release-0-21-fixes/mythtv/bindings/perl/MythTV/Channel.pm $
+# @date      $Date: 2007-03-13 06:13:27 +0100 (Di, 13. Mär 2007) $
 # @version   $Revision: 13029 $
 # @author    $Author: xris $
 #
diff -uNr mythtv-0.21/bindings/perl/MythTV/Program.pm mythtv/bindings/perl/MythTV/Program.pm
--- mythtv-0.21/bindings/perl/MythTV/Program.pm	2007-11-30 00:45:24.000000000 +0100
+++ mythtv/bindings/perl/MythTV/Program.pm	2007-11-30 00:45:24.000000000 +0100
@@ -3,8 +3,8 @@
 #
 # Object containing info about a particular MythTV program.
 #
-# @url       $URL: http://svn.mythtv.org/svn/tags/release-0-21/mythtv/bindings/perl/MythTV/Program.pm $
-# @date      $Date: 2007-11-29 23:45:24 +0000 (Thu, 29 Nov 2007) $
+# @url       $URL: http://svn.mythtv.org/svn/branches/release-0-21-fixes/mythtv/bindings/perl/MythTV/Program.pm $
+# @date      $Date: 2007-11-30 00:45:24 +0100 (Fr, 30. Nov 2007) $
 # @version   $Revision: 14997 $
 # @author    $Author: xris $
 #
diff -uNr mythtv-0.21/bindings/perl/MythTV/Recording.pm mythtv/bindings/perl/MythTV/Recording.pm
--- mythtv-0.21/bindings/perl/MythTV/Recording.pm	2008-03-05 05:29:54.000000000 +0100
+++ mythtv/bindings/perl/MythTV/Recording.pm	2008-03-05 05:29:54.000000000 +0100
@@ -3,8 +3,8 @@
 #
 # Object containing info about a particular MythTV recording.
 #
-# @url       $URL: http://svn.mythtv.org/svn/tags/release-0-21/mythtv/bindings/perl/MythTV/Recording.pm $
-# @date      $Date: 2008-03-05 04:29:54 +0000 (Wed, 05 Mar 2008) $
+# @url       $URL: http://svn.mythtv.org/svn/branches/release-0-21-fixes/mythtv/bindings/perl/MythTV/Recording.pm $
+# @date      $Date: 2008-03-05 05:29:54 +0100 (Mi, 05. Mär 2008) $
 # @version   $Revision: 16398 $
 # @author    $Author: xris $
 #
diff -uNr mythtv-0.21/bindings/perl/MythTV/StorageGroup.pm mythtv/bindings/perl/MythTV/StorageGroup.pm
--- mythtv-0.21/bindings/perl/MythTV/StorageGroup.pm	2007-01-06 21:45:00.000000000 +0100
+++ mythtv/bindings/perl/MythTV/StorageGroup.pm	2007-01-06 21:45:00.000000000 +0100
@@ -4,7 +4,7 @@
 # Object containing info about a particular MythTV Storage Group.
 #
 # @url       $URL: svn+ssh://cpinkham@cvs.mythtv.org/var/lib/svn/trunk/mythtv/bindings/perl/MythTV/StorageGroup.pm $
-# @date      $Date: 2007-01-06 20:45:00 +0000 (Sat, 06 Jan 2007) $
+# @date      $Date: 2007-01-06 21:45:00 +0100 (Sa, 06. Jan 2007) $
 # @version   $Revision: 12434 $
 # @author    $Author: xris $
 #
diff -uNr mythtv-0.21/bindings/perl/MythTV.pm mythtv/bindings/perl/MythTV.pm
--- mythtv-0.21/bindings/perl/MythTV.pm	2008-03-05 17:17:02.000000000 +0100
+++ mythtv/bindings/perl/MythTV.pm	2008-03-05 17:17:02.000000000 +0100
@@ -1,8 +1,8 @@
 #
 # MythTV bindings for perl.
 #
-# @url       $URL: http://svn.mythtv.org/svn/tags/release-0-21/mythtv/bindings/perl/MythTV.pm $
-# @date      $Date: 2008-03-05 16:17:02 +0000 (Wed, 05 Mar 2008) $
+# @url       $URL: http://svn.mythtv.org/svn/branches/release-0-21-fixes/mythtv/bindings/perl/MythTV.pm $
+# @date      $Date: 2008-03-05 17:17:02 +0100 (Mi, 05. Mär 2008) $
 # @version   $Revision: 16401 $
 # @author    $Author: rkulagow $
 #
diff -uNr mythtv-0.21/contrib/channel_changers/6200ch.c mythtv/contrib/channel_changers/6200ch.c
--- mythtv-0.21/contrib/channel_changers/6200ch.c	2008-03-04 18:43:47.000000000 +0100
+++ mythtv/contrib/channel_changers/6200ch.c	2009-04-25 05:52:16.000000000 +0200
@@ -34,8 +34,14 @@
 // WARNING: Please update firewiredevice.cpp when adding to this list.
 
 #define DCH3200_VENDOR_ID1 0x00001c11
+#define DCH3200_VENDOR_ID2 0x00001cfb
+#define DCH3200_VENDOR_ID3 0x00001fc4
+#define DCH3200_VENDOR_ID4 0x000023a3
 #define DCH3200_MODEL_ID1  0x0000d330
 
+#define DCH3416_VENDOR_ID1 0x00001e46
+#define DCH3416_MODEL_ID1  0x0000b630
+
 #define DCT3412_VENDOR_ID1 0x0000159a
 #define DCT3412_MODEL_ID1  0x000034cb
 
@@ -62,6 +68,7 @@
 #define DCT6200_VENDOR_ID13 0x00001aad
 #define DCT6200_VENDOR_ID14 0x00000b06
 #define DCT6200_VENDOR_ID15 0x0000195e
+#define DCT6200_VENDOR_ID16 0x000010dc
 #define DCT6200_SPEC_ID    0x00005068
 #define DCT6200_SW_VERSION 0x00010101
 #define DCT6200_MODEL_ID1  0x0000620a
@@ -76,13 +83,42 @@
 #define DCT6416_VENDOR_ID2 0x00001a66 
 #define DCT6416_MODEL_ID1  0x0000646b
 
-#define AVC1394_SUBUNIT_TYPE_6200 (9 << 19)  /* uses a reserved subunit type */ 
+#define QIP7100_VENDOR_ID1 0x00002374
+#define QIP7100_MODEL_ID1  0x00008100
+#define QIP7100_MODEL_ID2  0x00000001
+
+#define MOT_UNKNOWN_VENDOR_ID1 0x04db
+#define MOT_UNKNOWN_VENDOR_ID2 0x0406
+#define MOT_UNKNOWN_VENDOR_ID3 0x0ce5
+#define MOT_UNKNOWN_VENDOR_ID4 0x111a
+#define MOT_UNKNOWN_VENDOR_ID5 0x1225
+#define MOT_UNKNOWN_VENDOR_ID6 0x1404
+#define MOT_UNKNOWN_VENDOR_ID7 0x1626
+#define MOT_UNKNOWN_VENDOR_ID8 0x18c0
+#define MOT_UNKNOWN_VENDOR_ID9 0x1ade
+#define MOT_UNKNOWN_VENDOR_ID10 0x1cfb
+#define MOT_UNKNOWN_VENDOR_ID11 0x2040
+#define MOT_UNKNOWN_VENDOR_ID12 0x211e
+#define MOT_UNKNOWN_VENDOR_ID13 0x2180
+#define MOT_UNKNOWN_VENDOR_ID14 0x2210
+#define MOT_UNKNOWN_VENDOR_ID15 0x230b
+#define MOT_UNKNOWN_VENDOR_ID16 0x2375
+#define MOT_UNKNOWN_VENDOR_ID17 0x2395
+#define MOT_UNKNOWN_VENDOR_ID18 0x23a2
+#define MOT_UNKNOWN_VENDOR_ID19 0x23ed
+#define MOT_UNKNOWN_VENDOR_ID20 0x23ee
+#define MOT_UNKNOWN_VENDOR_ID21 0x23a0
+#define MOT_UNKNOWN_VENDOR_ID22 0x23a1
+
+#define PACE_VENDOR_ID1    0x00005094 /* 550 & 779 */
+#define PACE_VENDOR_ID2    0x00005094 /* unknown */
+#define PACE550_MODEL_ID1  0x00010551
+#define PACE779_MODEL_ID1  0x00010755
 
-#define AVC1394_6200_COMMAND_CHANNEL 0x000007C00   /* 6200 subunit command */
 #define AVC1394_6200_OPERAND_SET 0x20      /* 6200 subunit command operand */
 
-#define CTL_CMD0 AVC1394_CTYPE_CONTROL | AVC1394_SUBUNIT_TYPE_6200 | \
-        AVC1394_SUBUNIT_ID_0 | AVC1394_6200_COMMAND_CHANNEL | \
+#define CTL_CMD0 AVC1394_CTYPE_CONTROL | AVC1394_SUBUNIT_TYPE_PANEL | \
+        AVC1394_SUBUNIT_ID_0 | AVC1394_PANEL_COMMAND_PASS_THROUGH | \
         AVC1394_6200_OPERAND_SET
 
 #define STARTING_NODE 1  /* skip 1394 nodes to avoid error msgs */
@@ -171,7 +207,7 @@
 
    if (!handle) {
       if (!errno) {
-         fprintf(stderr, "Not Compatable!\n");
+         fprintf(stderr, "Not Compatible!\n");
       } else {
          perror("Couldn't get 1394 handle");
          fprintf(stderr, "Is ieee1394, driver, and raw1394 loaded?\n");
@@ -218,9 +254,13 @@
 
       // WARNING: Please update firewiredevice.cpp when adding to this list.
       if ( ((dir.vendor_id == DCH3200_VENDOR_ID1) ||
-            (dir.vendor_id == DCT3412_VENDOR_ID1) || 
-            (dir.vendor_id == DCT3416_VENDOR_ID1) || 
-            (dir.vendor_id == DCT3416_VENDOR_ID2) || 
+            (dir.vendor_id == DCH3200_VENDOR_ID2) ||
+            (dir.vendor_id == DCH3200_VENDOR_ID3) ||
+            (dir.vendor_id == DCH3200_VENDOR_ID4) ||
+            (dir.vendor_id == DCH3416_VENDOR_ID1) ||
+            (dir.vendor_id == DCT3412_VENDOR_ID1) ||
+            (dir.vendor_id == DCT3416_VENDOR_ID1) ||
+            (dir.vendor_id == DCT3416_VENDOR_ID2) ||
             (dir.vendor_id == DCT5100_VENDOR_ID1) ||
             (dir.vendor_id == DCT6200_VENDOR_ID1) ||
             (dir.vendor_id == DCT6200_VENDOR_ID2) ||
@@ -237,11 +277,38 @@
             (dir.vendor_id == DCT6200_VENDOR_ID13) ||
             (dir.vendor_id == DCT6200_VENDOR_ID14) ||
             (dir.vendor_id == DCT6200_VENDOR_ID15) ||
+            (dir.vendor_id == DCT6200_VENDOR_ID16) ||
             (dir.vendor_id == DCT6412_VENDOR_ID1) ||
             (dir.vendor_id == DCT6412_VENDOR_ID2) ||
-            (dir.vendor_id == DCT6416_VENDOR_ID1) || 
-            (dir.vendor_id == DCT6416_VENDOR_ID2)) &&
+            (dir.vendor_id == DCT6416_VENDOR_ID1) ||
+            (dir.vendor_id == DCT6416_VENDOR_ID2) ||
+            (dir.vendor_id == QIP7100_VENDOR_ID1) ||
+            (dir.vendor_id == MOT_UNKNOWN_VENDOR_ID1) ||
+            (dir.vendor_id == MOT_UNKNOWN_VENDOR_ID2) ||
+            (dir.vendor_id == MOT_UNKNOWN_VENDOR_ID3) ||
+            (dir.vendor_id == MOT_UNKNOWN_VENDOR_ID4) ||
+            (dir.vendor_id == MOT_UNKNOWN_VENDOR_ID5) ||
+            (dir.vendor_id == MOT_UNKNOWN_VENDOR_ID6) ||
+            (dir.vendor_id == MOT_UNKNOWN_VENDOR_ID7) ||
+            (dir.vendor_id == MOT_UNKNOWN_VENDOR_ID8) ||
+            (dir.vendor_id == MOT_UNKNOWN_VENDOR_ID9) ||
+            (dir.vendor_id == MOT_UNKNOWN_VENDOR_ID10) ||
+            (dir.vendor_id == MOT_UNKNOWN_VENDOR_ID11) ||
+            (dir.vendor_id == MOT_UNKNOWN_VENDOR_ID12) ||
+            (dir.vendor_id == MOT_UNKNOWN_VENDOR_ID13) ||
+            (dir.vendor_id == MOT_UNKNOWN_VENDOR_ID14) ||
+            (dir.vendor_id == MOT_UNKNOWN_VENDOR_ID15) ||
+            (dir.vendor_id == MOT_UNKNOWN_VENDOR_ID16) ||
+            (dir.vendor_id == MOT_UNKNOWN_VENDOR_ID17) ||
+            (dir.vendor_id == MOT_UNKNOWN_VENDOR_ID18) ||
+            (dir.vendor_id == MOT_UNKNOWN_VENDOR_ID19) ||
+            (dir.vendor_id == MOT_UNKNOWN_VENDOR_ID20) ||
+            (dir.vendor_id == MOT_UNKNOWN_VENDOR_ID21) ||
+            (dir.vendor_id == MOT_UNKNOWN_VENDOR_ID22) ||
+            (dir.vendor_id == PACE_VENDOR_ID1) ||
+            (dir.vendor_id == PACE_VENDOR_ID2)) &&
            ((dir.model_id == DCH3200_MODEL_ID1) ||
+            (dir.model_id == DCH3416_MODEL_ID1) ||
             (dir.model_id == DCT3412_MODEL_ID1) ||
             (dir.model_id == DCT3416_MODEL_ID1) ||
             (dir.model_id == DCT3416_MODEL_ID2) ||
@@ -250,7 +317,12 @@
             (dir.model_id == DCT6200_MODEL_ID2) ||
             (dir.model_id == DCT6412_MODEL_ID1) ||
             (dir.model_id == DCT6412_MODEL_ID2) ||
-            (dir.model_id == DCT6416_MODEL_ID1)) ) {
+            (dir.model_id == DCT6416_MODEL_ID1) ||
+            (dir.model_id == QIP7100_MODEL_ID1) ||
+            (dir.model_id == QIP7100_MODEL_ID2) ||
+            (dir.model_id == PACE550_MODEL_ID1) ||
+            (dir.model_id == PACE779_MODEL_ID1)) )
+      {
             if (dir.unit_spec_id != DCT6200_SPEC_ID)
                fprintf(stderr, "Warning: Unit Spec ID different.\n");
             if (dir.unit_sw_version != DCT6200_SW_VERSION)
diff -uNr mythtv-0.21/contrib/channel_changers/sa3250ch.c mythtv/contrib/channel_changers/sa3250ch.c
--- mythtv-0.21/contrib/channel_changers/sa3250ch.c	2007-11-18 17:19:20.000000000 +0100
+++ mythtv/contrib/channel_changers/sa3250ch.c	2009-04-25 05:52:16.000000000 +0200
@@ -32,13 +32,24 @@
 
 /* SA3250HD IDs */
 /* WARNING: Please update firewiredevice.cpp when adding to this list. */
-#define SA_VENDOR_ID1           0x000011e6
-#define SA_VENDOR_ID2           0x000014f8
-#define SA_VENDOR_ID3           0x00001692
-#define SA_VENDOR_ID4           0x00001947
-#define SA_VENDOR_ID5           0x00000f21
-#define SA_VENDOR_ID6           0x00001ac3
-#define SA_VENDOR_ID7           0x00000a73
+
+#define SA_VENDOR_ID1           0x00000a73
+#define SA_VENDOR_ID2           0x00000f21
+#define SA_VENDOR_ID3           0x000011e6
+#define SA_VENDOR_ID4           0x000014f8
+#define SA_VENDOR_ID5           0x00001692
+#define SA_VENDOR_ID6           0x00001868
+#define SA_VENDOR_ID7           0x00001947
+#define SA_VENDOR_ID8           0x00001ac3
+#define SA_VENDOR_ID9           0x00001bd7
+#define SA_VENDOR_ID10          0x00001cea
+#define SA_VENDOR_ID11          0x00001e6b
+#define SA_VENDOR_ID12          0x000021be
+#define SA_VENDOR_ID13          0x0000223a
+#define SA_VENDOR_ID14          0x000022ce
+#define SA_VENDOR_ID15          0x000023be
+#define SA_VENDOR_ID16          0x0000252e
+
 #define SA3250HD_MODEL_ID1      0x00000be0
 #define SA4200HD_MODEL_ID1      0x00001072
 #define SA4250HDC_MODEL_ID1     0x000010cc
@@ -130,13 +141,22 @@
                  i, dir.vendor_id, dir.model_id); 
 		
       /* WARNING: Please update firewiredevice.cpp when adding to this list. */
-      if (((dir.vendor_id == SA_VENDOR_ID1) ||
-           (dir.vendor_id == SA_VENDOR_ID2) ||
-           (dir.vendor_id == SA_VENDOR_ID3) ||
-           (dir.vendor_id == SA_VENDOR_ID4) ||
-           (dir.vendor_id == SA_VENDOR_ID5) ||
-           (dir.vendor_id == SA_VENDOR_ID6) ||
-           (dir.vendor_id == SA_VENDOR_ID7)) &&
+      if (((dir.vendor_id == SA_VENDOR_ID1)  ||
+           (dir.vendor_id == SA_VENDOR_ID2)  ||
+           (dir.vendor_id == SA_VENDOR_ID3)  ||
+           (dir.vendor_id == SA_VENDOR_ID4)  ||
+           (dir.vendor_id == SA_VENDOR_ID5)  ||
+           (dir.vendor_id == SA_VENDOR_ID6)  ||
+           (dir.vendor_id == SA_VENDOR_ID7)  ||
+           (dir.vendor_id == SA_VENDOR_ID8)  ||
+           (dir.vendor_id == SA_VENDOR_ID9)  ||
+           (dir.vendor_id == SA_VENDOR_ID10) ||
+           (dir.vendor_id == SA_VENDOR_ID11) ||
+           (dir.vendor_id == SA_VENDOR_ID12) ||
+           (dir.vendor_id == SA_VENDOR_ID13) ||
+           (dir.vendor_id == SA_VENDOR_ID14) ||
+           (dir.vendor_id == SA_VENDOR_ID15) ||
+           (dir.vendor_id == SA_VENDOR_ID16)) &&
           ((dir.model_id == SA3250HD_MODEL_ID1)  ||
            (dir.model_id == SA4200HD_MODEL_ID1)  ||
            (dir.model_id == SA4250HDC_MODEL_ID1)))
diff -uNr mythtv-0.21/contrib/configfiles/lircrc.native.example.mceusb2 mythtv/contrib/configfiles/lircrc.native.example.mceusb2
--- mythtv-0.21/contrib/configfiles/lircrc.native.example.mceusb2	2006-06-12 07:18:38.000000000 +0200
+++ mythtv/contrib/configfiles/lircrc.native.example.mceusb2	2006-06-12 07:18:38.000000000 +0200
@@ -2,7 +2,7 @@
 # lircrc config file for the Microsoft Media Center Edition Remote, model 1039
 #
 # @url       $URL$
-# @date      $Date: 2006-06-12 05:18:38 +0000 (Mon, 12 Jun 2006) $
+# @date      $Date: 2006-06-12 07:18:38 +0200 (Mo, 12. Jun 2006) $
 # @version   $Revision: 10187 $
 # @author    $Author: xris $
 #
diff -uNr mythtv-0.21/contrib/icons/master_iconmap/channel_icons.pl mythtv/contrib/icons/master_iconmap/channel_icons.pl
--- mythtv-0.21/contrib/icons/master_iconmap/channel_icons.pl	2007-03-23 06:38:00.000000000 +0100
+++ mythtv/contrib/icons/master_iconmap/channel_icons.pl	2007-03-23 06:38:00.000000000 +0100
@@ -5,8 +5,8 @@
 # Also does searches for artwork URLs based on callsign or xmltvid, or displays
 # the master iconmap xml file from services.mythtv.org.
 #
-# @url       $URL: http://svn.mythtv.org/svn/tags/release-0-21/mythtv/contrib/icons/master_iconmap/channel_icons.pl $
-# @date      $Date: 2007-03-23 05:38:00 +0000 (Fri, 23 Mar 2007) $
+# @url       $URL: http://svn.mythtv.org/svn/branches/release-0-21-fixes/mythtv/contrib/icons/master_iconmap/channel_icons.pl $
+# @date      $Date: 2007-03-23 06:38:00 +0100 (Fr, 23. Mär 2007) $
 # @version   $Revision: 13114 $
 # @author    $Author: xris $
 # @copyright MythTV
diff -uNr mythtv-0.21/contrib/mythrename.pl mythtv/contrib/mythrename.pl
--- mythtv-0.21/contrib/mythrename.pl	2008-02-17 06:02:51.000000000 +0100
+++ mythtv/contrib/mythrename.pl	2008-02-17 06:02:51.000000000 +0100
@@ -7,7 +7,7 @@
 # the mythtv recording directory from the database (code from nuvexport).
 #
 # @url       $URL$
-# @date      $Date: 2008-02-17 05:02:51 +0000 (Sun, 17 Feb 2008) $
+# @date      $Date: 2008-02-17 06:02:51 +0100 (So, 17. Feb 2008) $
 # @version   $Revision: 16112 $
 # @author    $Author: xris $
 # @license   GPL
diff -uNr mythtv-0.21/contrib/optimize_mythdb.pl mythtv/contrib/optimize_mythdb.pl
--- mythtv-0.21/contrib/optimize_mythdb.pl	2007-08-04 11:25:32.000000000 +0200
+++ mythtv/contrib/optimize_mythdb.pl	2007-08-04 11:25:32.000000000 +0200
@@ -4,7 +4,7 @@
 # finds.  Suggested use is to cron it to run once per day.
 #
 # @url       $URL$
-# @date      $Date: 2007-08-04 09:25:32 +0000 (Sat, 04 Aug 2007) $
+# @date      $Date: 2007-08-04 11:25:32 +0200 (Sa, 04. Aug 2007) $
 # @version   $Revision: 14140 $
 # @author    $Author: xris $
 # @license   GPL
diff -uNr mythtv-0.21/contrib/OSX/osx-packager.pl mythtv/contrib/OSX/osx-packager.pl
--- mythtv-0.21/contrib/OSX/osx-packager.pl	2008-02-26 04:18:10.000000000 +0100
+++ mythtv/contrib/OSX/osx-packager.pl	2009-05-07 01:39:26.000000000 +0200
@@ -4,10 +4,10 @@
 ### osx-packager.pl
 ###
 ### = revision
-### $Id: osx-packager.pl 16258 2008-02-26 03:18:10Z nigel $
+### $Id: osx-packager.pl 20497 2009-05-06 23:39:26Z nigel $
 ###
 ### = location
-### http://svn.mythtv.org/svn/trunk/mythtv/contrib/OSX/osx-packager.pl
+### http://svn.mythtv.org/svn/branches/release-0-21-fixes/mythtv/contrib/OSX/osx-packager.pl
 ###
 ### = description
 ### Tool for automating frontend builds on Mac OS X.
@@ -77,6 +77,7 @@
 our %depend_order = (
   'mythtv'
   =>  [
+        'faad2',
         'freetype',
         'lame',
         'mysqlclient',
@@ -111,7 +112,7 @@
     'url'
     => 'http://subversion.tigris.org/downloads/subversion-1.4.3.tar.bz2',
     'pre-conf'
-    => 'tar -xjf ../subversion-deps-1.4.3.tar.bz2',
+    => 'tar -xjf ../subversion-deps-1.4.3.tar.bz2 -C ..',
     'conf'
     =>  [
            '--disable-keychain',  # Workaround a 10.3 build problem
@@ -122,15 +123,17 @@
     #=> 'yes'
   },
 
-  'freetype'
-  =>
+  'faad2' => 
+  { 
+    'url' => "$sourceforge/sourceforge/faac/faad2-2.7.tar.gz", 
+  },
+
+  'freetype' =>
   {
-    'url'
-    =>  "$sourceforge/sourceforge/freetype/freetype-2.1.10.tar.gz",
+    'url' => "$sourceforge/sourceforge/freetype/freetype-2.1.10.tar.gz",
   },
 
-  'lame'
-  =>
+  'lame' =>
   {
     'url'
     =>  "$sourceforge/sourceforge/lame/lame-3.96.1.tar.gz",
@@ -180,7 +183,7 @@
   =>
   {
     'url' 
-    => 'http://mysql.osuosl.org/Downloads/MySQL-4.1/mysql-4.1.22.tar.gz',
+    => 'http://mirror.provenscaling.com/mysql/community/source/4.1/mysql-4.1.22.tar.gz',
     'conf'
     =>  [
           '--without-debug',
@@ -195,35 +198,6 @@
   
   'qt-mt'
   =>
-#   {
-#     'url'
-#     =>  'http://ftp.iasi.roedu.net/mirrors/ftp.trolltech.com/qt/sources/qt-mac-opensource-src-4.0.1.tar.gz',
-#     'conf-cmd'
-#     =>  'echo yes | ./configure',
-#     'conf'
-#     =>  [
-#           '-prefix', '"$PREFIX"',
-#           '-system-zlib',
-#           '-fast',
-#           '-qt-sql-mysql',
-#           '-qt-libpng',
-#           '-qt-libjpeg',
-#           '-qt-gif',
-#           '-platform macx-g++',
-#           '-no-tablet',
-#           '-I"$PREFIX/include/mysql"',
-#           '-L"$PREFIX/lib/mysql"',
-#         ],
-#     'post-conf'
-#     =>  'echo "QMAKE_LFLAGS_SHLIB += -single_module" >> src/qt.pro',
-#     'make'
-#     =>  [
-#           'sub-src',
-#           'qmake-install',
-#           'moc-install',
-#           'src-install'
-#         ],
-#   },
   {
     'url'
     =>  'http://ftp.iasi.roedu.net/mirrors/ftp.trolltech.com/qt/source/qt-mac-free-3.3.8.tar.gz',
@@ -367,11 +341,8 @@
   'exif'
   =>
   {
-    'url'  => "$sourceforge/sourceforge/libexif/libexif-0.6.13.tar.bz2",
-    'conf' => [ '--disable-nls' ],
-    'post-conf' => 'echo "install-apidocs:
-install-apidocs-internals:
-" >> doc/Makefile.in'
+    'url'  => "$sourceforge/sourceforge/libexif/libexif-0.6.17.tar.bz2",
+    'conf' => [ '--disable-docs' ]
   }
 );
 
@@ -536,6 +507,15 @@
   die;
 }
 
+if ( ! $OPT{'svnbranch'} )
+{
+    &Complain(<<END);
+This script can probably only build branch release-0-21-fixes.
+To build SVN HEAD, please try the latest version instead. e.g.
+http://svn.mythtv.org/svn/trunk/packaging/OSX/build/osx-packager.pl
+END
+}
+
 our $WORKDIR = "$SCRIPTDIR/.osx-packager";
 mkdir $WORKDIR;
 
@@ -555,6 +535,8 @@
 our $SRCDIR = "$WORKDIR/src";
 mkdir $SRCDIR;
 
+our $SVNDIR = "$SRCDIR/myth-svn";
+
 # configure mythplugins, and mythtv, etc
 our %conf = (
   'mythplugins'
@@ -577,6 +559,8 @@
   'mythtv'
   =>  [
         '--prefix=' . $PREFIX,
+        '--runtime-prefix=../Resources',
+        '--enable-libfaad', 
         # To "cross compile" something for a lesser Mac:
         #'--tune=G3',
         #'--disable-altivec',
@@ -633,7 +617,8 @@
 $cpus =~ s/.*, (\d+) processors$/$1/;
 if ( $cpus gt 1 )
 {
-  &Verbose("Using $cpus parallel CPUs");
+  &Verbose("Using", $cpus+1, "jobs on $cpus parallel CPUs");
+  ++$cpus;
   $parallel_make_flags = "-j$cpus";
 }
 
@@ -646,7 +631,11 @@
   &Syscall([ '/bin/rm', '-f', '-r', '$PREFIX/lib/libmyth*' ]);
   &Syscall([ '/bin/rm', '-f', '-r', '$PREFIX/lib/mythtv'   ]);
   &Syscall([ '/bin/rm', '-f', '-r', '$PREFIX/share/mythtv' ]);
-  &Syscall([ '/bin/rm', '-f', '-r', $SRCDIR ]);
+  &Syscall([ 'find', $SVNDIR, '-name', '*.o',     '-delete' ]);
+  &Syscall([ 'find', $SVNDIR, '-name', '*.a',     '-delete' ]);
+  &Syscall([ 'find', $SVNDIR, '-name', '*.dylib', '-delete' ]);
+  &Syscall([ 'find', $SVNDIR, '-name', '*.orig',  '-delete' ]);
+  &Syscall([ 'find', $SVNDIR, '-name', '*.rej',   '-delete' ]);
   exit;
 }
 
@@ -668,6 +657,21 @@
 ### Third party packages
 my (@build_depends, %seen_depends);
 my @comps = ('mythtv', @components);
+
+# Deal with user-supplied skip arguments
+if ( $OPT{'mythtvskip'} )
+{   @comps = grep(!m/mythtv/,      @comps)   }
+if ( $OPT{'pluginskip'} )
+{   @comps = grep(!m/mythplugins/, @comps)   }
+if ( $OPT{'themeskip'} )
+{   @comps = grep(!m/myththemes/,  @comps)   }
+
+if ( ! @comps )
+{
+  &Complain("Nothing to build! Too many ...skip arguments?");
+  exit;
+}
+
 &Verbose("Including components:", @comps);
 
 # If no SubVersion in path, and we are checking something out, build SVN:
@@ -705,7 +709,7 @@
   unless (-e $filename)
   {
     &Verbose("Downloading $sw");
-    unless (&Syscall([ '/usr/bin/curl', '-L', $url, '>', $filename ],
+    unless (&Syscall([ '/usr/bin/curl', '-f', '-L', $url, '>', $filename ],
                      'munge' => 1))
     {
       &Syscall([ '/bin/rm', $filename ]) if (-e $filename);
@@ -847,8 +851,7 @@
 }
 }
 
-my $svndir = "$SRCDIR/myth-svn";
-mkdir $svndir;
+mkdir $SVNDIR;
 
 # Deal with Subversion branches, revisions and tags:
 my $svnrepository = 'http://svn.mythtv.org/svn/';
@@ -898,34 +901,20 @@
 if (! $OPT{'nohead'})
 {
   # Empty subdirectory 'config' sometimes causes checkout problems
-  &Syscall(['rm', '-fr', $svndir . '/mythtv/config']);
+  &Syscall(['rm', '-fr', $SVNDIR . '/mythtv/config']);
   Verbose("Checking out source code");
   &Syscall([ $svn, 'co', @svnrevision,
-            map($svnrepository . $_, @comps), $svndir ]) or die;
+            map($svnrepository . $_, @comps), $SVNDIR ]) or die;
 }
 else
 {
-  &Syscall("mkdir -p $svndir/mythtv/config")
-}
-
-# Deal with user-supplied skip arguments
-if ( $OPT{'mythtvskip'} )
-{   @comps = grep(!m/mythtv/,      @comps)   }
-if ( $OPT{'pluginskip'} )
-{   @comps = grep(!m/mythplugins/, @comps)   }
-if ( $OPT{'themeskip'} )
-{   @comps = grep(!m/myththemes/,  @comps)   }
-
-if ( ! @comps )
-{
-  &Complain("Nothing to build! Too many ...skip arguments?");
-  exit;
+  &Syscall("mkdir -p $SVNDIR/mythtv/config")
 }
 
 # Build MythTV and any plugins
 foreach my $comp (@comps)
 {
-  my $compdir = "$svndir/$comp/" ;
+  my $compdir = "$SVNDIR/$comp/" ;
 
   chdir $compdir;
 
@@ -1037,10 +1026,18 @@
 $VERS .= '.' . $OPT{'version'} if $OPT{'version'};
 
 ### Program which creates bundles:
-our @bundler = "$svndir/mythtv/contrib/OSX/osx-bundler.pl";
+our @bundler = "$SVNDIR/mythtv/contrib/OSX/osx-bundler.pl";
 if ( $OPT{'verbose'} )
 {   push @bundler, '--verbose'   }
 
+
+### Framework that has a screwed up link dependency path
+my $AVCfw = '/Developer/FireWireSDK*/Examples/' .
+            'Framework/AVCVideoServices.framework';
+my @AVCfw = split / /, `ls -d $AVCfw`;
+$AVCfw = pop @AVCfw;
+chop $AVCfw;
+
 ### Create each package.
 ### Note that this is a bit of a waste of disk space,
 ### because there are now multiple copies of each library.
@@ -1060,7 +1057,7 @@
   # Get a fresh copy of the binary
   &Verbose("Building self-contained $target");
   &Syscall([ 'rm', '-fr', $finalTarget ]) or die;
-  &Syscall([ 'cp',  "$svndir/mythtv/programs/$builtTarget/$builtTarget",
+  &Syscall([ 'cp',  "$SVNDIR/mythtv/programs/$builtTarget/$builtTarget",
              "$SCRIPTDIR/$target" ]) or die;
 
   # Convert it to a bundled .app
@@ -1068,10 +1065,12 @@
              "$PREFIX/lib/", "$PREFIX/lib/mysql" ])
       or die;
 
-
   # Remove copy of binary
   unlink "$SCRIPTDIR/$target" or die;
 
+  if ( $AVCfw )
+  {  &RecursiveCopy($AVCfw, "$finalTarget/Contents/Frameworks")  }
+
  if ( $target eq "MythFrontend" or $target =~ m/^MythTV/ )
  {
   my $res  = "$finalTarget/Contents/Resources";
@@ -1088,8 +1087,12 @@
   foreach my $lib ( glob "$libs/mythtv/*/*" )
   {   &Syscall([ @bundler, $lib ]) or die   }
 
+  # Allow Finder's 'Get Info' to manage plugin list:
+  &Syscall([ 'mv', $plug, "$finalTarget/Contents/Plugins" ]) or die;
+  &Syscall([ 'ln', '-s', "../../../Plugins", $plug ]) or die;
+
   # The icon
-  &Syscall([ 'cp',  "$svndir/mythtv/programs/mythfrontend/mythfrontend.icns",
+  &Syscall([ 'cp',  "$SVNDIR/mythtv/programs/mythfrontend/mythfrontend.icns",
              "$res/application.icns" ]) or die;
   &Syscall([ '/Developer/Tools/SetFile', '-a', 'C', $finalTarget ]) or die;
  }
@@ -1179,7 +1182,7 @@
     my ($src, $dst) = @_;
 
     # First copy absolutely everything
-    &Syscall([ '/bin/cp', '-R', "$src", "$dst"]) or die;
+    &Syscall([ '/bin/cp', '-pR', "$src", "$dst"]) or die;
 
     # Then strip out any .svn directories
     my @files = map { chomp $_; $_ } `find $dst -name .svn`;
@@ -1197,7 +1200,7 @@
 }
 
 ######################################
-## CleanMakefiles removes every Makefile
+## CleanMakefiles removes every generated Makefile
 ## from our MythTV build that contains PREFIX.
 ## Necessary when we change the
 ## PREFIX variable.
@@ -1207,7 +1210,7 @@
 {
   &Verbose("Cleaning MythTV makefiles containing PREFIX");
   &Syscall([ 'find', '.', '-name', 'Makefile', '-exec',
-             'egrep', '-q', 'PREFIX', '{}', ';', '-delete' ]) or die;
+             'egrep', '-q', 'qmake.*PREFIX', '{}', ';', '-delete' ]) or die;
 } # end CleanMakefiles
 
 
diff -uNr mythtv-0.21/contrib/Win32/MythInstaller.bat mythtv/contrib/Win32/MythInstaller.bat
--- mythtv-0.21/contrib/Win32/MythInstaller.bat	1970-01-01 01:00:00.000000000 +0100
+++ mythtv/contrib/Win32/MythInstaller.bat	2008-06-02 05:00:06.000000000 +0200
@@ -0,0 +1,69 @@
+@rem = '--*-Perl-*--
+@rem
+@rem Wrapper for bootstrapping Windows build and install.
+@rem Checks for Perl, attempts to download latest win32-packager.pl,
+@rem and then executes that with any supplied arguments.
+@rem 
+
+@echo off
+
+if "%OS%" == "Windows_NT" setlocal
+set PERL5LIB=
+set PERLLIB=
+set PERL5OPT=
+set PERLIO=
+set PERL_UNICODE=
+if "%OS%" == "Windows_NT" goto WinNT
+perl -x -S "%0" %1 %2 %3 %4 %5 %6 %7 %8 %9
+goto endofperl
+
+:WinNT
+if not exist c:\perl\bin\perl.exe goto no_perl
+@rem
+@rem If we needed any non-standard Perl modules, this is how to install them:
+@rem if NOT exist C:\Perl\site\lib\Config\inifiles.pm call c:\perl\bin\ppm.bat install Config-inifiles
+@rem if errorlevel 1  echo You do not have Perl in your PATH. 
+@rem
+perl -x -S %0 %*
+if NOT "%COMSPEC%" == "%SystemRoot%\system32\cmd.exe" goto endofperl
+if %errorlevel% == 9009 echo You do not have Perl in your PATH.
+if errorlevel 1 goto script_failed_so_exit_with_non_zero_val 2>nul
+goto endofperl
+
+:no_perl
+echo Could not find Perl in C:\Perl.
+echo Please download ActivePerl from http://www.activestate.com/store
+echo        install it, and then run this script again.
+sleep 1
+c:\windows\explorer http://www.activestate.com/store/activeperl/download
+goto endofperl
+
+@rem ';
+#!c:/perl/bin/perl.exe -w
+use strict;
+use LWP::UserAgent;
+use IO::File; 
+
+my $file = 'win32-packager.pl';
+my $url  = "http://svn.mythtv.org/svn/trunk/mythtv/contrib/Win32/build/$file";
+my $proxy = ''; # or somehting like: 'http://enter.your.proxy.here:8080';
+
+my $ua = LWP::UserAgent->new;
+$ua->proxy(['http', 'ftp'], $proxy);
+my $req = HTTP::Request->new(GET => $url);
+my $res = $ua->request($req);
+
+if ($res->is_success) {
+    my $f = new IO::File "> $file" || die "Can't create $file: $!\n";
+    $f->binmode();
+    $f->print($res->content);
+    $f->close();
+}
+
+if ( ! -s $file ) {
+    die "Cannot download $url";
+}
+
+exec "c:/perl/bin/perl.exe -w $file @ARGV";
+__END__
+:endofperl
diff -uNr mythtv-0.21/contrib/Win32/run/mythbackend.cmd mythtv/contrib/Win32/run/mythbackend.cmd
--- mythtv-0.21/contrib/Win32/run/mythbackend.cmd	1970-01-01 01:00:00.000000000 +0100
+++ mythtv/contrib/Win32/run/mythbackend.cmd	2008-04-24 05:07:09.000000000 +0200
@@ -0,0 +1,58 @@
+@Echo off
+::
+:: Script to run mythbackend through gdb (easily?)
+:: There is likely a more efficient way of doing this, 
+:: but we have to start somewhere.
+::
+Echo COMMENTS: --------------------------------------
+Echo COMMENTS: This script is used for gathering backtraces using gdb
+Echo COMMENTS: See: http://www.mythtv.org/docs/mythtv-HOWTO-22.html#ss22.2
+Echo COMMENTS: See: http://www.mythtv.org/wiki/index.php/Windows_Port
+Echo COMMENTS: --------------------------------------
+Echo.
+::
+:gdbcommands
+::
+:: Check for and Create if needed the .\gdbcommands.txt 
+::
+:: syntax taken from [ http://www.mythtv.org/docs/mythtv-HOWTO.html#toc22.2 ] 
+::
+if not exist ./gdbcommands.txt (
+    echo handle SIGPIPE nostop noprint > .\gdbcommands.txt
+    echo handle SIG33   nostop noprint >> .\gdbcommands.txt
+    echo set logging on     >> .\gdbcommands.txt
+    echo set pagination off >> .\gdbcommands.txt
+    echo set args -l myth.log --noupnp --nosched --nojobqueue --nohousekeeper --noautoexpire -v all >> .\gdbcommands.txt
+    echo run >> .\gdbcommands.txt
+    echo thread apply all bt full >> .\gdbcommands.txt
+    echo set logging off >> .\gdbcommands.txt )
+@Echo off
+
+Echo COMMENTS: --------------------------------------
+Echo COMMENTS: Clearing old gdb.txt before running gdb again.
+Echo COMMENTS: --------------------------------------
+Echo. 
+::
+:: add current data/time to gdb.txt 
+:: will this be a bad idea? who knows? =) 
+::
+date /t > .\gdb.txt
+time /t >> .\gdb.txt
+
+:gdb
+::
+:: gdb should be in the path. 
+::
+Echo COMMENTS: --------------------------------------
+Echo COMMENTS: If you need to add any switches to mythbackend edit gdbcommands.txt
+Echo COMMENTS: see: "mythbackend.exe --help" for options
+Echo COMMENTS: --------------------------------------
+Echo.
+Echo COMMENTS: --------------------------------------
+Echo COMMENTS: Starting: gdb
+Echo COMMENTS: --------------------------------------
+gdb .\mythbackend.exe -x .\gdbcommands.txt
+
+Echo.
+Echo The backtrace can be found in .\gdb.txt
+Echo.
